/////////////////////////////////////////
////           Przykad 11.           ////
////      Komunikacja MODBUS         ////
////   13.04.2015 ukasz Grniak     ////
/////////////////////////////////////////

// Zmienne MODBUS
//Zmienne typu REAL
#AKT_POZ_X  $R0
#AKT_POZ_Y  $R2
#AKT_PRE_Z  $R4

//Zmienne typu INTEGER 
#NUMER_POZ      $I100
#START_MODBUS   $I101

//Wejcia - Wyjcia
#START              IN3
#NASTEPNY_PUNKT     IN1
#PRZYSPIESZ         IN2

#DIODA_1            OUT1
#DIODA_2            OUT2


CFGINT_IN7 = RIS        //Konfiguracja przerwania - wejcie IN7 - STOP AWARYJNY  
CFGINT_IN4 = RIS        //Konfiguracja przerwania - wejcie IN4 - Zatrzymanie napdu M3
CFGINT_MODBUS = HIGH    //Konfiguracja przerwania MADBUS

// Ustawienie parametrw ruchu napdu M1 bdacych parametrami ruchu dla interpolacji
AccM1 = 500
DecM1 = 500
VmaxM1 = 100

// Ustawienie parametrw ruchu napdu M2
AccM2 = 500
DecM2 = 500
VmaxM2 = 100

//Uruchomienie napdw
SET GO=0
WHILE GO=0                    //Moliwo startu protramu poprzez wejcie IN3 lub rejestrach MODBUS I101
  IF START=1
    GO=1
  ENDIF

  IF START_MODBUS=1
    GO=1
  ENDIF
ENDWHILE

M1 = ON        //Uruchomienie napdw - Ustawienie sygnau ENABLE
M2 = ON
M3 = ON

//Bazowanie napdw
HOME M1 -10    //Bazowanie napdu M1 z prdkoci 10 w lew stron 
HOME M2 -10    //Bazowanie napdu M2 z prdkoci 10 w lew stron 
WAITPOS

MAIN:
    
    IF PRZYSPIESZ = ON          //Sprawdzenie stanu przycisku PRZYSPIESZ
       DELAY 0.2
       VREL M3 20               //Jeli przycisk wcinity zwikszenie prdkoci napdu M3 o 10 jednostek
       SET SKOK = SKOK+1        //Zwikszenie zmiennej SKOK kontrolujcej maksymaln prdko
       AKT_PRE_Z=VactM3
    ENDIF

    
    IF SKOK=10                  //Jeli prdko zbyt dua   
        STOP M3 0               //Zatrzymanie napdu M3
        VABS M3 0               //Ustawienie prdkoci absolutnej napdu M3 na 0
        WAIT VactM3 = 0         //Oczekiwanie na Zatrzymanie napdu M3
        AKT_PRE_Z=VactM3        //Przypisanie prdkoci napdu M3 do zmiennej MODBUS
        SKOK = 0
    ENDIF
    
    IF NASTEPNY_PUNKT=ON        //Sprawdzenie stanu przycisku NASTPNY_PUNKT
        SET LICZBA = LICZBA + 1 //Przejciedo kolejnego punktu
        NUMER_POZ = LICZBA      //Aktualizacja numeru pozycji
    ENDIF
    
    IF LICZBA = 1
        PABS M1  100        //Zadanie pozycji absolutnej dla napdw M1, M2
        PABS M2  100
        WAITPOS
    ENDIF
    
    IF LICZBA = 2
        PREL M1  7          //Zadanie pozycji relatywnej dla napdw M1, M2
        PREL M2  7
        WAITPOS
       SET LICZBA = LICZBA + 1
    ENDIF
    
    IF LICZBA = 4
        MOVEPTP @POZYCJA_1 //Zadanie pozycji z tablicy  pod nazw POZYCJA_1
        WAITPOS
    ENDIF
    
    IF LICZBA = 5
        LICZBA=0
        MOVEPTP 1          //Zadanie pozycji z tablicy  pod numerem 1
        WAITPOS
    ENDIF
    
 AKT_POZ_X  =  PosM1     // Aktualizacja pozycji aktualnej w rejestrach MODBUS
 AKT_POZ_Y  =  PosM2
    
JUMP MAIN

INT_IN4:
    BRAKE M3
RETURN


INT_IN7:                //Przerwanie STOP AWARYJNY
    STOP M1             //Zatrzymanie napdw
    STOP M2
    STOP M3

    M1 = OFF           //Wyczenie napdw
    M2 = OFF
    M3 = OFF

    WAIT IN7=OFF       //Oczekiwanie na wyciniecie stopu awaryjnego

    //Zerowanie warunkw pocztkowych
    LICZBA = 0
    VABS M3 0          //Ustawienie prdkoci absolutnej napdu M3 na 0
    SKOK = 0

    //Reset programu
    PROGRESET          

RETURN

//Miganie diod w przerwaniu MODBUS
INT_MODBUS:
    DIODA_1 = !DIODA_1  //Zmiana stanu wyjcia na przeciwny
RETURN 






















